﻿### BCS ###
$bcsSAName = "Business Data Connectivity Service" 
Write-Host "Creating BCS Service and Proxy..." 
$BCSDBName = ("{0}_SA_BCS" -f $FarmName)
New-SPBusinessDataCatalogServiceApplication -Name $bcsSAName -ApplicationPool $saAppPoolName -DatabaseServer $databaseServerName -DatabaseName $BCSDBName > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Business Data Connectivity Service"} | Start-SPServiceInstance > $null  
   
	### BCS Partitioned ###
	$bcsSAName = "Business Data Connectivity Service Partitioned 2" 
	Write-Host "Creating BCS Service and Proxy..." 
	$BCSDBName = ("{0}_SA_BCS_2" -f $FarmName)
	New-SPBusinessDataCatalogServiceApplication -PartitionMode -Name $bcsSAName -ApplicationPool $saAppPoolName -DatabaseServer $databaseServerName -DatabaseName $BCSDBName > $null  
	Get-SPServiceInstance | where-object {$_.TypeName -eq "Business Data Connectivity Service"} | Start-SPServiceInstance > $null  
   
### Secure Store ###
$secureStoreSAName = "Secure Store Service" 
Write-Host "Creating Secure Store Service and Proxy..." 
$storeDB = ("{0}_SA_SecureStore" -f $FarmName)
New-SPSecureStoreServiceapplication -Name $secureStoreSAName -Sharing:$false -DatabaseServer $databaseServerName -DatabaseName $storeDB -ApplicationPool $saAppPoolName -auditingEnabled:$true -auditlogmaxsize 30 | New-SPSecureStoreServiceApplicationProxy -name "$secureStoreSAName Proxy" -DefaultProxygroup > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Secure Store Service"} | Start-SPServiceInstance > $null  
  
	 ### Secure Store Partitioned ###
	 $secureStoreSAName = "Secure Store Service Partitioned" 
	 Write-Host "Creating Secure Store Service and Proxy..." 
	 $storeDB = ("{0}_SA_SecureStore" -f $FarmName)
	 New-SPSecureStoreServiceapplication -PartitionMode -Name $secureStoreSAName -Sharing:$false -DatabaseServer $databaseServerName -DatabaseName $storeDB -ApplicationPool $saAppPoolName -auditingEnabled:$true -auditlogmaxsize 30 | New-SPSecureStoreServiceApplicationProxy -name "$secureStoreSAName Proxy" -DefaultProxygroup > $null  
	 Get-SPServiceInstance | where-object {$_.TypeName -eq "Secure Store Service"} | Start-SPServiceInstance > $null  
   
   
### META DATA ###    
$metadataSAName = "Managed Metadata Web Service" 
Write-Host "Creating Metadata Service and Proxy..." 
$metadataDB = ("{0}_SA_MetaData" -f $FarmName)
New-SPMetadataServiceApplication -Name $metadataSAName -ApplicationPool $saAppPoolName -DatabaseServer $databaseServerName -DatabaseName $metadataDB > $null  
New-SPMetadataServiceApplicationProxy -Name "$metadataSAName Proxy" -DefaultProxyGroup -ServiceApplication $metadataSAName > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Managed Metadata Web Service"} | Start-SPServiceInstance > $null  
 
     #Meta data Partitioned
	 $metadataSAName = "Managed Metadata Web Service Partitioned" 
	 Write-Host "Creating Metadata Service and Proxy..." 
	 $metadataDB = ("{0}_SA_MetaData_Partitioned" -f $FarmName)
	 New-SPMetadataServiceApplication -PartitionMode -Name $metadataSAName -ApplicationPool $saAppPoolName -DatabaseServer $databaseServerName -DatabaseName $metadataDB > $null  
	 New-SPMetadataServiceApplicationProxy -PartitionMode -Name "$metadataSAName Proxy" -DefaultProxyGroup -ServiceApplication $metadataSAName > $null  
	 Get-SPServiceInstance | where-object {$_.TypeName -eq "Managed Metadata Web Service"} | Start-SPServiceInstance > $null   


### USER PROFILE ###
$userProfileSAName = "User Profile Synchronization Service" 
Write-Host "Creating User Profile Service and Proxy..." 
$profileDB = ("{0}_SA_Profile" -f $FarmName)
$socialDB = ("{0}_SA_ProfileSocial" -f $FarmName)
$syncDB = ("{0}_SA_ProfileSync" -f $FarmName)
$userProfileService = New-SPProfileServiceApplication -Name $userProfileSAName -ApplicationPool $saAppPoolName -ProfileDBServer $databaseServerName -ProfileDBName $profileDB -SocialDBServer $databaseServerName -SocialDBName $socialDB -ProfileSyncDBServer $databaseServerName -ProfileSyncDBName $syncDB 
New-SPProfileServiceApplicationProxy -Name "$userProfileSAName Proxy" -ServiceApplication $userProfileService -DefaultProxyGroup > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "User Profile Service"} | Start-SPServiceInstance > $null  
    
	# UPS Partitioned - create on publisher
	$userProfileSAName = "User Profile Synchronization Service Partitioned" 
	Write-Host "Creating User Profile Service and Proxy..." 
	$profileDB = ("{0}_SA_Profile_Partitioned" -f $FarmName)
	$socialDB = ("{0}_SA_ProfileSocial_Partitioned" -f $FarmName)
	$syncDB = ("{0}_SA_ProfileSync_Partitioned" -f $FarmName)
	$userProfileService = New-SPProfileServiceApplication -PartitionMode -Name $userProfileSAName -ApplicationPool $saAppPoolName -ProfileDBServer $databaseServerName -ProfileDBName $profileDB -SocialDBServer $databaseServerName -SocialDBName $socialDB -ProfileSyncDBServer $databaseServerName -ProfileSyncDBName $syncDB 
	New-SPProfileServiceApplicationProxy -PartitionMode -Name "$userProfileSAName Proxy" -ServiceApplication $userProfileService -DefaultProxyGroup > $null  
	Get-SPServiceInstance | where-object {$_.TypeName -eq "User Profile Service"} | Start-SPServiceInstance > $null  

### WORD CONVERSION ####
$WordAutomationSAName = "Word Automation Services" 
Write-Host "Creating Word Conversion Service and Proxy..." 
$wordDB = ("{0}_SA_WordAutomation" -f $FarmName)
New-SPWordConversionServiceApplication -PartitionMode -Name $WordAutomationSAName -ApplicationPool $saAppPoolName -DatabaseServer $databaseServerName -DatabaseName $wordDB -Default > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Word Automation Services"} | Start-SPServiceInstance > $null 

	# Word Conversion partitioned
	$WordAutomationSAName = "Word Automation Services Partitioned" 
	Write-Host "Creating Word Conversion Service and Proxy..." 
	$wordDB = ("{0}_SA_WordAutomation_Partitioned" -f $FarmName)
	New-SPWordConversionServiceApplication -PartitionMode -Name $WordAutomationSAName -ApplicationPool $saAppPoolName -DatabaseServer $databaseServerName -DatabaseName $wordDB -Default > $null  
	Get-SPServiceInstance | where-object {$_.TypeName -eq "Word Automation Services"} | Start-SPServiceInstance > $null 

### STATE SERVICE ###
$stateSAName = "State Service" 
Write-Host "Creating State Service and Proxy..." 
$stateDB = ("{0}_SA_State" -f $FarmName)
New-SPStateServiceDatabase -Name $stateDB -DatabaseServer $databaseServerName | New-SPStateServiceApplication -Name $stateSAName | New-SPStateServiceApplicationProxy -Name "$stateSAName Proxy" -DefaultProxyGroup > $null  

### USAGE ###
$usageSAName = "Usage and Health Data Collection Service" 
Write-Host "Creating Usage Service and Proxy..." 
$serviceInstance = Get-SPUsageService  
$usageDBName = ("{0}_SA_Usage" -f $FarmName)
New-SPUsageApplication -Name $usageSAName -DatabaseServer $databaseServerName -DatabaseName $usageDBName -UsageService $serviceInstance > $null  

### ACCESS ###   
$accesssSAName = "Access Services" 
Write-Host "Creating Access Services and Proxy..." 
New-SPAccessServiceApplication -Name $accesssSAName -ApplicationPool $saAppPoolName > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Access Database Service"} | Start-SPServiceInstance > $null  

### EXCEL SERVICES ###
$excelSAName = "Excel Services Application" 
Write-Host "Creating Excel Service..." 
New-SPExcelServiceApplication -name $excelSAName –ApplicationPool $saAppPoolName > $null  
Set-SPExcelFileLocation -Identity "http://" -ExcelServiceApplication $excelSAName -ExternalDataAllowed 2 -WorkbookSizeMax 10 -WarnOnDataRefresh:$true  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Excel Calculation Services"} | Start-SPServiceInstance > $null  

### VISIO ####
$visioSAName = "Visio Graphics Service" 
Write-Host "Creating Visio Graphics Service and Proxy..." 
New-SPVisioServiceApplication -Name $visioSAName -ApplicationPool $saAppPoolName > $null  
New-SPVisioServiceApplicationProxy -Name "$visioSAName Proxy" -ServiceApplication $visioSAName > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Visio Graphics Service"} | Start-SPServiceInstance > $null   

### PERFORMANCE POINT ###
$performancePointSAName = $FarmName+"_SA_PP" #GUID ALWAYS attached to PP SA! :(
Write-Host "Creating Performance Point Service and Proxy..." 
New-SPPerformancePointServiceApplication -Name $performancePointSAName -ApplicationPool $saAppPoolName > $null  
New-SPPerformancePointServiceApplicationProxy -Default -Name "$performancePointSAName Proxy" -ServiceApplication $performancePointSAName > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "PerformancePoint Service"} | Start-SPServiceInstance > $null  

### WEB ANALYTICS ###
$WebAnalyticsSAName = "Web Analytics Service" 
Write-Host "Creating Web Analytics Service and Proxy..." 
$analyticsStageDB = ("{0}_SA_AnalyticsStage" -f $FarmName)
$analyticsWareDB = ("{0}_SA_AnalyticsWarehouse" -f $FarmName)
$stagerSubscription = "<StagingDatabases><StagingDatabase ServerName='$databaseServerName' DatabaseName='$analyticsStageDB'/></StagingDatabases>" 
$reportingSubscription = "<ReportingDatabases><ReportingDatabase ServerName='$databaseServerName' DatabaseName='$analyticsWareDB'/></ReportingDatabases>"  
New-SPWebAnalyticsServiceApplication -Name $WebAnalyticsSAName -ApplicationPool $saAppPoolName -ReportingDataRetention 20 -SamplingRate 100 -ListOfReportingDatabases $reportingSubscription -ListOfStagingDatabases $stagerSubscription > $null    
New-SPWebAnalyticsServiceApplicationProxy -Name "$WebAnalyticsSAName Proxy" -ServiceApplication $WebAnalyticsSAName > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Web Analytics Web Service"} | Start-SPServiceInstance > $null  
Get-SPServiceInstance | where-object {$_.TypeName -eq "Web Analytics Data Processing Service"} | Start-SPServiceInstance > $null  
  

# SEARCH (NOTE PARTITIONED FLAG EMBEDDED) #### 
# Note - kudos to Russ and Colin from Microsoft at putting this script
# together. Original source found at:
# http://blogs.msdn.com/b/russmax/archive/2009/10/20/sharepoint-2010-configuring-search-service-application-using-powershell.aspx
Write-Host "Creating Search Service and Proxy..." 

# 1.Setting up some initial variables. 
write-host 1.Setting up some initial variables. 
$SSAName = "SharePoint Server Search" 
$SVCAcct = $appPoolUserName 
$SSI = get-spenterprisesearchserviceinstance -local 
$err = $null 

# Start Services search services for SSI 
write-host Start Services search services for SSI 
Start-SPEnterpriseSearchServiceInstance -Identity $SSI 

# 2.Create an Application Pool. 
write-host 2.Create an Application Pool. 
$AppPool = new-SPServiceApplicationPool -name $SSAName"-AppPool" -account $SVCAcct 

# 3.Create the SearchApplication and set it to a variable 
write-host 3.Create the SearchApplication and set it to a variable 
$searchDB = ("{0}_SA_Search" -f $FarmName)
$SearchApp = New-SPEnterpriseSearchServiceApplication -Partitioned -Name $SSAName -applicationpool $AppPool -databasename $searchDB 

#4 Create search service application proxy 
write-host 4 Create search service application proxy 
$SSAProxy = new-spenterprisesearchserviceapplicationproxy -Partitioned -name $SSAName"ApplicationProxy" -Uri $SearchApp.Uri.AbsoluteURI 

# 5.Provision Search Admin Component. 
write-host 5.Provision Search Admin Component. 
set-SPenterprisesearchadministrationcomponent -searchapplication $SearchApp  -searchserviceinstance $SSI 

# 6.Create a new Crawl Topology. 
write-host 6.Create a new Crawl Topology. 
$CrawlTopo = $SearchApp | New-SPEnterpriseSearchCrawlTopology 

# 7.Create a new Crawl Store. 
write-host 7.Create a new Crawl Store. 
$CrawlStore = $SearchApp | Get-SPEnterpriseSearchCrawlDatabase 

# 8.Create a new Crawl Component. 
write-host 8.Create a new Crawl Component. 
New-SPEnterpriseSearchCrawlComponent -CrawlTopology $CrawlTopo -CrawlDatabase $CrawlStore -SearchServiceInstance $SSI 

# 9.Activate the Crawl Topology. 
write-host 9.Activate the Crawl Topology. 
do 
{ 
    $err = $null 
    $CrawlTopo | Set-SPEnterpriseSearchCrawlTopology -Active -ErrorVariable err 
    if ($CrawlTopo.State -eq "Active") 
    { 
        $err = $null 
    } 
    Start-Sleep -Seconds 10 
} 
until ($err -eq $null) 

# 10.Create a new Query Topology. 
write-host 10.Create a new Query Topology. 
$QueryTopo = $SearchApp | New-SPenterpriseSEarchQueryTopology -partitions 1 

# 11.Create a variable for the Query Partition 
write-host 11.Create a variable for the Query Partition 
$Partition1 = ($QueryTopo | Get-SPEnterpriseSearchIndexPartition) 

# 12.Create a Query Component. 
write-host 12.Create a Query Component. 
New-SPEnterpriseSearchQueryComponent -indexpartition $Partition1 -QueryTopology $QueryTopo -SearchServiceInstance $SSI 

# 13.Create a variable for the Property Store DB. 
write-host 13.Create a variable for the Property Store DB. 
$PropDB = $SearchApp | Get-SPEnterpriseSearchPropertyDatabase 

# 14.Set the Query Partition to use the Property Store DB. 
write-host 14.Set the Query Partition to use the Property Store DB. 
$Partition1 | Set-SPEnterpriseSearchIndexPartition -PropertyDatabase $PropDB 

# 15.Activate the Query Topology. 
write-host 15.Activate the Query Topology. 
do 
{ 
    $err = $null 
    $QueryTopo | Set-SPEnterpriseSearchQueryTopology -Active -ErrorVariable err -ErrorAction SilentlyContinue 
    Start-Sleep -Seconds 5 
    if ($QueryTopo.State -eq "Active") 
        { 
            $err = $null 
        } 
} 
until ($err -eq $null) 

Write-host "Your search application $SSAName is now ready"