﻿Add-PSSnapin microsoft.sharepoint.powershell  -ea silentlycontinue

#validate pre-reqs
$app = Get-SPServiceApplication |? {$_.TypeName -eq "Microsoft SharePoint Foundation Subscription Settings Service Application"}
if($app -eq $null){
 "Settings Service Application must already exist"
 exit;
}

#Create an alias for Add-SPSiteSubscriptionFeaturePackMember 
Set-Alias AddFeature Add-SPSiteSubscriptionFeaturePackMember



#Foundation Feature Pack
$ffp = New-SPSiteSubscriptionFeaturePack
AddFeature -identity $ffp -FeatureDefinition AdminLinks -ea SilentlyContinue                                                                                                                            
AddFeature -identity $ffp -FeatureDefinition AnnouncementsList -ea SilentlyContinue                                                                                                                     
AddFeature -identity $ffp -FeatureDefinition BasicWebParts -ea SilentlyContinue                                                                                                                         
AddFeature -identity $ffp -FeatureDefinition CallTrackList -ea SilentlyContinue                                                                                                                         
AddFeature -identity $ffp -FeatureDefinition CirculationList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $ffp -FeatureDefinition ContactsList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition CTypes -ea SilentlyContinue                                                                                                                                
AddFeature -identity $ffp -FeatureDefinition CustomList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $ffp -FeatureDefinition DataSourceLibrary -ea SilentlyContinue                                                                                                                     
AddFeature -identity $ffp -FeatureDefinition DiscussionsList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $ffp -FeatureDefinition DocumentLibrary -ea SilentlyContinue                                                                                                                       
AddFeature -identity $ffp -FeatureDefinition EventsList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $ffp -FeatureDefinition ExternalList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition FacilityList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition FCGroupsList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition Fields -ea SilentlyContinue                                                                                                                                
AddFeature -identity $ffp -FeatureDefinition GanttTasksList -ea SilentlyContinue                                                                                                                        
AddFeature -identity $ffp -FeatureDefinition GBWProvision -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition GBWWebParts -ea SilentlyContinue                                                                                                                           
AddFeature -identity $ffp -FeatureDefinition GridList -ea SilentlyContinue                                                                                                                              
AddFeature -identity $ffp -FeatureDefinition GroupWork -ea SilentlyContinue                                                                                                                             
AddFeature -identity $ffp -FeatureDefinition HelpLibrary -ea SilentlyContinue                                                                                                                           
AddFeature -identity $ffp -FeatureDefinition HolidaysList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition IMEDicList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $ffp -FeatureDefinition IssuesList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $ffp -FeatureDefinition IssueTrackingWorkflow -ea SilentlyContinue                                                                                                                 
AddFeature -identity $ffp -FeatureDefinition LinksList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $ffp -FeatureDefinition MobilityRedirect -ea SilentlyContinue                                                                                                                      
AddFeature -identity $ffp -FeatureDefinition MpsWebParts -ea SilentlyContinue                                                                                                                           
AddFeature -identity $ffp -FeatureDefinition NoCodeWorkflowLibrary -ea SilentlyContinue                                                                                                                 
AddFeature -identity $ffp -FeatureDefinition OpenInClient -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition PictureLibrary -ea SilentlyContinue                                                                                                                        
AddFeature -identity $ffp -FeatureDefinition ScheduleList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition SiteHelp -ea SilentlyContinue                                                                                                                              
AddFeature -identity $ffp -FeatureDefinition SurveysList -ea SilentlyContinue                                                                                                                           
AddFeature -identity $ffp -FeatureDefinition TasksList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $ffp -FeatureDefinition TeamCollab -ea SilentlyContinue                                                                                                                            
AddFeature -identity $ffp -FeatureDefinition TenantAdminBDC -ea SilentlyContinue                                                                                                                        
AddFeature -identity $ffp -FeatureDefinition TenantAdminLinks -ea SilentlyContinue                                                                                                                      
AddFeature -identity $ffp -FeatureDefinition TimeCardList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition WebPageLibrary -ea SilentlyContinue                                                                                                                        
AddFeature -identity $ffp -FeatureDefinition WhatsNewList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $ffp -FeatureDefinition WhereaboutsList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $ffp -FeatureDefinition WikiPageHomePage -ea SilentlyContinue                                                                                                                      
AddFeature -identity $ffp -FeatureDefinition WikiWelcome -ea SilentlyContinue                                                                                                                           
AddFeature -identity $ffp -FeatureDefinition WorkflowHistoryList -ea SilentlyContinue                                                                                                                   
AddFeature -identity $ffp -FeatureDefinition workflowProcessList -ea SilentlyContinue                                                                                                                   
AddFeature -identity $ffp -FeatureDefinition XmlFormLibrary -ea SilentlyContinue 



#Standard Feature Pack
$sfp = New-SPSiteSubscriptionFeaturePack
AddFeature -identity $sfp -FeatureDefinition AccSrvRestrictedList -ea SilentlyContinue                                                                                                                  
AddFeature -identity $sfp -FeatureDefinition AdminLinks -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition AdminReportCore -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition AnnouncementsList -ea SilentlyContinue                                                                                                                     
AddFeature -identity $sfp -FeatureDefinition AssetLibrary -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition BaseSite -ea SilentlyContinue                                                                                                                              
AddFeature -identity $sfp -FeatureDefinition BaseWeb -ea SilentlyContinue                                                                                                                               
AddFeature -identity $sfp -FeatureDefinition BasicWebParts -ea SilentlyContinue                                                                                                                         
AddFeature -identity $sfp -FeatureDefinition BDR -ea SilentlyContinue                                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition CallTrackList -ea SilentlyContinue                                                                                                                         
AddFeature -identity $sfp -FeatureDefinition CirculationList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition ContactsList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition ContentTypeHub -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition ContentTypePublish -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition CTypes -ea SilentlyContinue                                                                                                                                
AddFeature -identity $sfp -FeatureDefinition CustomList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition DataSourceLibrary -ea SilentlyContinue                                                                                                                     
AddFeature -identity $sfp -FeatureDefinition DeploymentLinks -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition DiscussionsList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition DocId -ea SilentlyContinue                                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition DocumentLibrary -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition DocumentRouting -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition DocumentRoutingResources -ea SilentlyContinue                                                                                                              
AddFeature -identity $sfp -FeatureDefinition DocumentSet -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition EMailRouting -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition EnhancedTheming -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition EnterpriseWiki -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition EnterpriseWikiLayouts -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition EventsList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition ExpirationWorkflow -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition ExternalList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition FacilityList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition FCGroupsList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition Fields -ea SilentlyContinue                                                                                                                                
AddFeature -identity $sfp -FeatureDefinition GanttTasksList -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition GBWProvision -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition GBWWebParts -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition GridList -ea SilentlyContinue                                                                                                                              
AddFeature -identity $sfp -FeatureDefinition GroupWork -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition HelpLibrary -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition Hold -ea SilentlyContinue                                                                                                                                  
AddFeature -identity $sfp -FeatureDefinition HolidaysList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition IMEDicList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition InPlaceRecords -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition IPFSTenantFormsConfig -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition IPFSTenantWebProxyConfig -ea SilentlyContinue                                                                                                              
AddFeature -identity $sfp -FeatureDefinition IPFSWebFeatures -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition IssuesList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition IssueTrackingWorkflow -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition LegacyDocumentLibrary -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition LegacyWorkflows -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition LinksList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition LocalSiteDirectoryControl -ea SilentlyContinue                                                                                                             
AddFeature -identity $sfp -FeatureDefinition LocalSiteDirectoryMetaData -ea SilentlyContinue                                                                                                            
AddFeature -identity $sfp -FeatureDefinition LocalSiteDirectorySettingsLink -ea SilentlyContinue                                                                                                        
AddFeature -identity $sfp -FeatureDefinition LocationBasedPolicy -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition MetaDataNav -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition MobilityRedirect -ea SilentlyContinue                                                                                                                      
AddFeature -identity $sfp -FeatureDefinition MpsWebParts -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition MySiteBlog -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition MySiteHost -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition MySiteHostPictureLibrary -ea SilentlyContinue                                                                                                              
AddFeature -identity $sfp -FeatureDefinition MySiteLayouts -ea SilentlyContinue                                                                                                                         
AddFeature -identity $sfp -FeatureDefinition MySiteNavigation -ea SilentlyContinue                                                                                                                      
AddFeature -identity $sfp -FeatureDefinition MySitePersonalSite -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition MySiteQuickLaunch -ea SilentlyContinue                                                                                                                     
AddFeature -identity $sfp -FeatureDefinition Navigation -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition NavigationProperties -ea SilentlyContinue                                                                                                                  
AddFeature -identity $sfp -FeatureDefinition NoCodeWorkflowLibrary -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition ObaProfilePages -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition ObaSimpleSolution -ea SilentlyContinue                                                                                                                     
AddFeature -identity $sfp -FeatureDefinition OffWFCommon -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition OpenInClient -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition OSearchHealthReports -ea SilentlyContinue                                                                                                                  
AddFeature -identity $sfp -FeatureDefinition OsrvLinks -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition OssNavigation -ea SilentlyContinue                                                                                                                         
AddFeature -identity $sfp -FeatureDefinition OSSSearchEndUserHelpFeature -ea SilentlyContinue                                                                                                           
AddFeature -identity $sfp -FeatureDefinition OSSSearchSearchCenterUrlFeature -ea SilentlyContinue                                                                                                       
AddFeature -identity $sfp -FeatureDefinition OSSSearchSearchCenterUrlSiteFeature -ea SilentlyContinue                                                                                                   
AddFeature -identity $sfp -FeatureDefinition PersonalizationSite -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition PictureLibrary -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition PortalLayouts -ea SilentlyContinue                                                                                                                         
AddFeature -identity $sfp -FeatureDefinition Publishing -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition PublishingLayouts -ea SilentlyContinue                                                                                                                     
AddFeature -identity $sfp -FeatureDefinition PublishingPrerequisites -ea SilentlyContinue                                                                                                               
AddFeature -identity $sfp -FeatureDefinition PublishingResources -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition PublishingSite -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition PublishingWeb -ea SilentlyContinue                                                                                                                         
AddFeature -identity $sfp -FeatureDefinition Ratings -ea SilentlyContinue                                                                                                                               
AddFeature -identity $sfp -FeatureDefinition RecordResources -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition RecordsCenter -ea SilentlyContinue                                                                                                                         
AddFeature -identity $sfp -FeatureDefinition RedirectPageContentTypeBinding -ea SilentlyContinue                                                                                                        
AddFeature -identity $sfp -FeatureDefinition RelatedLinksScopeSettingsLink -ea SilentlyContinue                                                                                                         
AddFeature -identity $sfp -FeatureDefinition ReportCenterSampleData -ea SilentlyContinue                                                                                                                
AddFeature -identity $sfp -FeatureDefinition Reporting -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition ReviewPublishingSPD -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition ReviewPublishingSPD1033 -ea SilentlyContinue                                                                                                               
AddFeature -identity $sfp -FeatureDefinition ReviewWorkflows -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition ReviewWorkflowsSPD -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition ReviewWorkflowsSPD1033 -ea SilentlyContinue                                                                                                                
AddFeature -identity $sfp -FeatureDefinition ScheduleList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition SearchAdminWebParts -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition SearchServerWizardFeature -ea SilentlyContinue                                                                                                             
AddFeature -identity $sfp -FeatureDefinition SearchWebParts -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition SignaturesWorkflow -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition SignaturesWorkflowSPD -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition SignaturesWorkflowSPD1033 -ea SilentlyContinue                                                                                                             
AddFeature -identity $sfp -FeatureDefinition SiteHelp -ea SilentlyContinue                                                                                                                              
AddFeature -identity $sfp -FeatureDefinition SitesList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition SlideLibrary -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition SSSvcAdmin -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition SurveysList -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition TasksList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition TaxonomyFieldAdded -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition TaxonomyTenantAdmin -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition TeamCollab -ea SilentlyContinue                                                                                                                            
AddFeature -identity $sfp -FeatureDefinition TenantAdminBDC -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition TenantAdminDeploymentLinks -ea SilentlyContinue                                                                                                            
AddFeature -identity $sfp -FeatureDefinition TenantAdminLinks -ea SilentlyContinue                                                                                                                      
AddFeature -identity $sfp -FeatureDefinition TenantAdminSecureStore -ea SilentlyContinue                                                                                                                
AddFeature -identity $sfp -FeatureDefinition TenantProfileAdmin -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition TimeCardList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition TranslationWorkflow -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition TransMgmtLib -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition UpgradeOnlyFile -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition V2VPublishedLinks -ea SilentlyContinue                                                                                                                     
AddFeature -identity $sfp -FeatureDefinition V2VPublishingLayouts -ea SilentlyContinue                                                                                                                  
AddFeature -identity $sfp -FeatureDefinition ViewFormPagesLockDown -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition WACentralAdminReports -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition WAMaster -ea SilentlyContinue                                                                                                                              
AddFeature -identity $sfp -FeatureDefinition WAReports -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition WAWhatsPopularWebPart -ea SilentlyContinue                                                                                                                 
AddFeature -identity $sfp -FeatureDefinition WebPageLibrary -ea SilentlyContinue                                                                                                                        
AddFeature -identity $sfp -FeatureDefinition WebPartAdderGroups -ea SilentlyContinue                                                                                                                    
AddFeature -identity $sfp -FeatureDefinition WhatsNewList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $sfp -FeatureDefinition WhereaboutsList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $sfp -FeatureDefinition WikiPageHomePage -ea SilentlyContinue                                                                                                                      
AddFeature -identity $sfp -FeatureDefinition WikiWelcome -ea SilentlyContinue                                                                                                                           
AddFeature -identity $sfp -FeatureDefinition WorkflowHistoryList -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition workflowProcessList -ea SilentlyContinue                                                                                                                   
AddFeature -identity $sfp -FeatureDefinition Workflows -ea SilentlyContinue                                                                                                                             
AddFeature -identity $sfp -FeatureDefinition XmlFormLibrary -ea SilentlyContinue



#Enterprise Feature Pack
$efp = New-SPSiteSubscriptionFeaturePack
AddFeature -identity $efp -FeatureDefinition AccSrvMSysAso -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition AccSrvRestrictedList -ea SilentlyContinue                                                                                                                  
AddFeature -identity $efp -FeatureDefinition AccSrvShell -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition AccSrvSolutionGallery -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition AccSrvUserTemplate -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition AccSrvUSysAppLog -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition AddDashboard -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition AdminLinks -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition AdminReportCore -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition AnnouncementsList -ea SilentlyContinue                                                                                                                     
AddFeature -identity $efp -FeatureDefinition AssetLibrary -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition BaseSite -ea SilentlyContinue                                                                                                                              
AddFeature -identity $efp -FeatureDefinition BaseWeb -ea SilentlyContinue                                                                                                                               
AddFeature -identity $efp -FeatureDefinition BasicWebParts -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition BDR -ea SilentlyContinue                                                                                                                                   
AddFeature -identity $efp -FeatureDefinition BICenterDashboardsLib -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition BICenterDataconnectionsLib -ea SilentlyContinue                                                                                                            
AddFeature -identity $efp -FeatureDefinition BICenterSampleData -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition BizAppsCTypes -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition BizAppsFields -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition BizAppsListTemplates -ea SilentlyContinue                                                                                                                  
AddFeature -identity $efp -FeatureDefinition BizAppsSiteTemplates -ea SilentlyContinue                                                                                                                  
AddFeature -identity $efp -FeatureDefinition CallTrackList -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition CirculationList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition ContactsList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition ContentTypeHub -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition ContentTypePublish -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition CTypes -ea SilentlyContinue                                                                                                                                
AddFeature -identity $efp -FeatureDefinition CustomList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition DataConnectionLibrary -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition DataSourceLibrary -ea SilentlyContinue                                                                                                                     
AddFeature -identity $efp -FeatureDefinition DeploymentLinks -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition DiscussionsList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition DocId -ea SilentlyContinue                                                                                                                                 
AddFeature -identity $efp -FeatureDefinition DocumentLibrary -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition DocumentRouting -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition DocumentRoutingResources -ea SilentlyContinue                                                                                                              
AddFeature -identity $efp -FeatureDefinition DocumentSet -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition EMailRouting -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition EnhancedTheming -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition EnterpriseWiki -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition EnterpriseWikiLayouts -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition EventsList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition ExcelServerDeactivateProgrammability -ea SilentlyContinue                                                                                                  
AddFeature -identity $efp -FeatureDefinition ExcelServerSite -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition ExcelServerWebPart -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition ExpirationWorkflow -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition ExternalList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition FacilityList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition FastCentralAdminHelpCollection -ea SilentlyContinue                                                                                                        
AddFeature -identity $efp -FeatureDefinition FastEndUserHelpCollection -ea SilentlyContinue                                                                                                             
AddFeature -identity $efp -FeatureDefinition FCGroupsList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition Fields -ea SilentlyContinue                                                                                                                                
AddFeature -identity $efp -FeatureDefinition GanttTasksList -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition GBWProvision -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition GBWWebParts -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition GridList -ea SilentlyContinue                                                                                                                              
AddFeature -identity $efp -FeatureDefinition GroupWork -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition HelpLibrary -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition Hold -ea SilentlyContinue                                                                                                                                  
AddFeature -identity $efp -FeatureDefinition HolidaysList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition IMEDicList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition InPlaceRecords -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition IPFSAdminWeb -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition IPFSSiteFeatures -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition IPFSTenantFormsConfig -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition IPFSTenantWebProxyConfig -ea SilentlyContinue                                                                                                              
AddFeature -identity $efp -FeatureDefinition IPFSWebFeatures -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition IssuesList -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition IssueTrackingWorkflow -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition LegacyDocumentLibrary -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition LegacyWorkflows -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition LinksList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition LocalSiteDirectoryControl -ea SilentlyContinue                                                                                                             
AddFeature -identity $efp -FeatureDefinition LocalSiteDirectoryMetaData -ea SilentlyContinue                                                                                                            
AddFeature -identity $efp -FeatureDefinition LocalSiteDirectorySettingsLink -ea SilentlyContinue                                                                                                        
AddFeature -identity $efp -FeatureDefinition LocationBasedPolicy -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition MetaDataNav -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition MobileExcelWebAccess -ea SilentlyContinue                                                                                                                  
AddFeature -identity $efp -FeatureDefinition MobilityRedirect -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition MossChart -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition MpsWebParts -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition MySiteBlog -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition MySiteHost -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition MySiteHostPictureLibrary -ea SilentlyContinue                                                                                                              
AddFeature -identity $efp -FeatureDefinition MySiteLayouts -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition MySiteNavigation -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition MySitePersonalSite -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition MySiteQuickLaunch -ea SilentlyContinue                                                                                                                     
AddFeature -identity $efp -FeatureDefinition Navigation -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition NavigationProperties -ea SilentlyContinue                                                                                                                  
AddFeature -identity $efp -FeatureDefinition NoCodeWorkflowLibrary -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition ObaProfilePages -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition ObaSimpleSolution -ea SilentlyContinue                                                                                                                     
AddFeature -identity $efp -FeatureDefinition OffWFCommon -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition OpenInClient -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition OSearchHealthReports -ea SilentlyContinue                                                                                                                  
AddFeature -identity $efp -FeatureDefinition OsrvLinks -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition OssNavigation -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition OSSSearchEndUserHelpFeature -ea SilentlyContinue                                                                                                           
AddFeature -identity $efp -FeatureDefinition OSSSearchSearchCenterUrlFeature -ea SilentlyContinue                                                                                                       
AddFeature -identity $efp -FeatureDefinition OSSSearchSearchCenterUrlSiteFeature -ea SilentlyContinue                                                                                                   
AddFeature -identity $efp -FeatureDefinition PersonalizationSite -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition PictureLibrary -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition PortalLayouts -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition PPSDatasourceLib -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition PPSMonDatasourceCtype -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition PPSSiteCollectionMaster -ea SilentlyContinue                                                                                                               
AddFeature -identity $efp -FeatureDefinition PPSSiteMaster -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition PPSWebParts -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition PPSWorkspaceCtype -ea SilentlyContinue                                                                                                                     
AddFeature -identity $efp -FeatureDefinition PPSWorkspaceList -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition PremiumSite -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition PremiumWeb -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition Publishing -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition PublishingLayouts -ea SilentlyContinue                                                                                                                     
AddFeature -identity $efp -FeatureDefinition PublishingPrerequisites -ea SilentlyContinue                                                                                                               
AddFeature -identity $efp -FeatureDefinition PublishingResources -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition PublishingSite -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition PublishingWeb -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition Ratings -ea SilentlyContinue                                                                                                                               
AddFeature -identity $efp -FeatureDefinition RecordResources -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition RecordsCenter -ea SilentlyContinue                                                                                                                         
AddFeature -identity $efp -FeatureDefinition RedirectPageContentTypeBinding -ea SilentlyContinue                                                                                                        
AddFeature -identity $efp -FeatureDefinition RelatedLinksScopeSettingsLink -ea SilentlyContinue                                                                                                         
AddFeature -identity $efp -FeatureDefinition ReportCenterSampleData -ea SilentlyContinue                                                                                                                
AddFeature -identity $efp -FeatureDefinition Reporting -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition ReportListTemplate -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition ReviewPublishingSPD -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition ReviewPublishingSPD1033 -ea SilentlyContinue                                                                                                               
AddFeature -identity $efp -FeatureDefinition ReviewWorkflows -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition ReviewWorkflowsSPD -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition ReviewWorkflowsSPD1033 -ea SilentlyContinue                                                                                                                
AddFeature -identity $efp -FeatureDefinition ScheduleList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition SearchAdminWebParts -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition SearchExtensions -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition SearchServerWizardFeature -ea SilentlyContinue                                                                                                             
AddFeature -identity $efp -FeatureDefinition SearchWebParts -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition SignaturesWorkflow -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition SignaturesWorkflowSPD -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition SignaturesWorkflowSPD1033 -ea SilentlyContinue                                                                                                             
AddFeature -identity $efp -FeatureDefinition SiteHelp -ea SilentlyContinue                                                                                                                              
AddFeature -identity $efp -FeatureDefinition SitesList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition SlideLibrary -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition SSSvcAdmin -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition SurveysList -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition TasksList -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition TaxonomyFieldAdded -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition TaxonomyTenantAdmin -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition TeamCollab -ea SilentlyContinue                                                                                                                            
AddFeature -identity $efp -FeatureDefinition TenantAdminBDC -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition TenantAdminDeploymentLinks -ea SilentlyContinue                                                                                                            
AddFeature -identity $efp -FeatureDefinition TenantAdminLinks -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition TenantAdminSecureStore -ea SilentlyContinue                                                                                                                
AddFeature -identity $efp -FeatureDefinition TenantProfileAdmin -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition TimeCardList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition TranslationWorkflow -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition TransMgmtLib -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition UpgradeOnlyFile -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition V2VPublishedLinks -ea SilentlyContinue                                                                                                                     
AddFeature -identity $efp -FeatureDefinition V2VPublishingLayouts -ea SilentlyContinue                                                                                                                  
AddFeature -identity $efp -FeatureDefinition ViewFormPagesLockDown -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition VisioProcessRepository -ea SilentlyContinue                                                                                                                
AddFeature -identity $efp -FeatureDefinition VisioProcessRepositoryUs -ea SilentlyContinue                                                                                                              
AddFeature -identity $efp -FeatureDefinition VisioWebAccess -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition WACentralAdminCustomReports -ea SilentlyContinue                                                                                                           
AddFeature -identity $efp -FeatureDefinition WACentralAdminReports -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition WACustomReports -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition WAMaster -ea SilentlyContinue                                                                                                                              
AddFeature -identity $efp -FeatureDefinition WAReports -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition WAWhatsPopularWebPart -ea SilentlyContinue                                                                                                                 
AddFeature -identity $efp -FeatureDefinition WebPageLibrary -ea SilentlyContinue                                                                                                                        
AddFeature -identity $efp -FeatureDefinition WebPartAdderGroups -ea SilentlyContinue                                                                                                                    
AddFeature -identity $efp -FeatureDefinition WhatsNewList -ea SilentlyContinue                                                                                                                          
AddFeature -identity $efp -FeatureDefinition WhereaboutsList -ea SilentlyContinue                                                                                                                       
AddFeature -identity $efp -FeatureDefinition WikiPageHomePage -ea SilentlyContinue                                                                                                                      
AddFeature -identity $efp -FeatureDefinition WikiWelcome -ea SilentlyContinue                                                                                                                           
AddFeature -identity $efp -FeatureDefinition WorkflowHistoryList -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition workflowProcessList -ea SilentlyContinue                                                                                                                   
AddFeature -identity $efp -FeatureDefinition Workflows -ea SilentlyContinue                                                                                                                             
AddFeature -identity $efp -FeatureDefinition XmlFormLibrary -ea SilentlyContinue

"Foundation Features: "+$ffp.ID
"Standard Features: "+$sfp.ID
"Enterprise Features: "+$efp.ID


$fpacks = Get-SPSiteSubscriptionFeaturePack
"Foundation Features: "+$fpacks[0].ID
"Standard Features: "+$fpacks[1].ID
"Enterprise Features: "+$fpacks[2].ID


$marketing = Get-SPSiteSubscription | Where-Object { $_.Id.ToString() -eq "d4b08002-3d68-484d-a62c-69c0dd76acca" }
Set-SPSiteSubscriptionConfig -Id $marketing -FeaturePack $ffp
$sales = Get-SPSiteSubscription | Where-Object { $_.Id.ToString() -eq "9d78e16e-5ded-4760-a7d5-7ac5edce4795" }
Set-SPSiteSubscriptionConfig -Id $sales -FeaturePack $sfp
Set-SPSiteSubscriptionConfig -Id $sales -FeaturePack $efp
$hr = Get-SPSiteSubscription | Where-Object { $_.Id.ToString() -eq "83322539-132f-4dc0-b8d6-221ce6a674fd" }
Set-SPSiteSubscriptionConfig -Id $hr -FeaturePack $sfp
